﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NetShop.models;
using NetShop.libs.encrypt;
using NetShop.libs.authentication;

namespace NetShop.controllers.user
{
    class AuthController
    {
        public static string register(string username, string password,string repassword)
        {
            if (password != repassword)
            {
                return "Mật khẩu nhập lại chưa khớp !";
            }
            if (username.Length == 0)
            {
                return "Bạn chưa nhập tên tài khoản !";
            }
            if (password.Length == 0)
            {
                return "Bạn chưa nhập mật khẩu !";
            }
            if (repassword.Length == 0)
            {
                return "Bạn chưa nhập lại mật khẩu !";
            }
            if (models.user.instance.checkExistUsername(username))
            {
                return "Tên tài khoản người dùng đã tồn tại !";
            }
            else
            {
                models.user.instance.create(username, md5.Hash(password));
                return "Đăng ký thành công !";
            }
        }

        public static bool login(string username, string password)
        {
            if (models.user.instance.checkExist(username, md5.Hash(password)))
            {
                auth.getInstance("user").attempt(username, password);
                return true;
            }
            return false;
        }
    }
}
