﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;

namespace NetShop.libs.database
{
    class modelBase
    {
        protected string table;

        private string queryTemp;

        private SqlConnection connection = new SqlConnection(@"Data Source=.\SQLEXPRESS;AttachDbFilename=D:\code\c#\NetShop\database\netshop.mdf;Integrated Security=True;Connect Timeout=30;User Instance=True");

        protected modelBase(string table)
        {
            this.table = table;
        }

        private Dictionary<string, object>[] saveData(SqlDataReader reader)
        {
            Dictionary<string, object>[] map = new Dictionary<string, object>[100];
            Int32 index = 0;
            while (reader.Read())
            {
                map[index] = new Dictionary<string, object>();
                for (Int32 i = 0; i < reader.FieldCount; i++)
                {
                    string key = reader.GetName(i).ToString();
                    map[index].Add(key, reader[key]);
                }
                index++;
            }
            return map;
        }

        private SqlCommand command(string query)
        {
            return new SqlCommand(query, connection);
        }

        public string getQuery()
        {
            return queryTemp;
        }

        public dynamic select(string obj)
        {
            queryTemp = "select " + obj + " from " + table;
            return this;
        }

        public dynamic where(string condition)
        {
            queryTemp += " where " + condition;
            return this;
        }

        public dynamic orderBy(string column,string type)
        {
            queryTemp += " order by " + column + " " + type;
            return this;
        }

        public dynamic like(string pattern)
        {
            queryTemp += " like " + pattern;
            return this;
        }

        public dynamic insert(string fields,string values)
        {
            queryTemp = "insert into " + table + " (" + fields + ") values(" + values + ")";
            /*queryTemp = "insert into " + table + " values(";
            for (Int32 i = 0; i < values.Count; i++)
            {
                if (values[i] != "null")
                {
                    queryTemp += "'" + values[i] + "'";
                }
                if (i < values.Count - 1)
                {
                    queryTemp += ",";
                }
                if (i == values.Count - 1)
                {
                    queryTemp += ")";
                }
            }*/
            return this;
        }

        public dynamic update(string sets,string whereCondition)
        {
            queryTemp += "update " + table + " set " + sets + " where " + whereCondition;
            return this;
        }

        public dynamic delete(string condition)
        {
            queryTemp += "delete from " + table + " where " + condition;
            return this;
        }

        public Dictionary<string, object>[] get()
        {
            connection.Open();
            /*code*/
            var cmd = command(queryTemp);
            var reader = (SqlDataReader)cmd.ExecuteReader();
            var data = saveData(reader);
            /*code-end*/
            connection.Close();
            return data;
        }

        public bool execute()
        {
            connection.Open();
            /*code*/
            var cmd = command(queryTemp);
            var result = false;
            try
            {
                if(cmd.ExecuteNonQuery() == 1)
                {
                    result = true;
                }
            }
            catch(Exception)
            {
                result = false;
            }
            /*code-end*/
            connection.Close();
            return result;
        }
    }
}
