﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using NetShop;
using NetShop.libs.form;
using NetShop.libs.authentication;

namespace NetShop.views
{
    public partial class main : Form
    {
        public main()
        {
            InitializeComponent();
            handle.getInstance(this).disableResize();
        }

        private void loginUser_Click(object sender, EventArgs e)
        {
            if (auth.getInstance("user").checkLogin())
            {
                handle.getInstance(new user.main()).show(2);
            }
            else
            {
                handle.getInstance(new user.auth.login()).show(2);
            }
        }

        private void loginAdmin_Click(object sender, EventArgs e)
        {
            if (auth.getInstance("admin").checkLogin())
            {
                handle.getInstance(new admin.main()).show(2);
            }
            else
            {
                handle.getInstance(new admin.auth.login()).show(2);
            }
        }

        private void registerUser_Click(object sender, EventArgs e)
        {
            handle.getInstance(new user.auth.register()).show(2);
        }
    }
}
